# Find the eigenvector from the dynamical matrice

import numpy as np

def read_dynamical_matrix(datafile):
	with open(datafile,'r') as f:
          raw = list()
          for line in f:
	    if line[0]=='#': continue
	    parts=line.split()
	    if not parts: continue
	    val=float(parts[4])
	    if np.abs(val) < 0.000000001:
	      val=0.0
            raw.append(val)
          dynmat = np.array(raw)
          dynmat = dynmat.reshape(6,6)
	return dynmat

L_file = '/home/Samuel/Dropbox/WorkDiam/DerivEig_L/Dyanmical_mat.dat'

dynmatL=read_dynamical_matrix(L_file)

[eigvalL,eigvectL]=np.linalg.eig(dynmatL)

eigvectL=np.transpose(eigvectL)
Mc=21894.16693

print "eigenvalues at L :"
for n in eigvalL:
  a = np.sqrt(n/Mc)
  print a

print "eigenvectors at L :"
for n in eigvectL: print n

# Create the xcart needed for abinit input file

disp1 = 0.05
disp2 = 0.05
rprim = np.array([6.70346805,6.70346805,6.70346805])

print "# Equilibrium position" 
print " xcart1  0.0  0.0  0.0                     # 0.0 0.0 0.0 "
print "         1.67586701 1.67586701 1.67586701  # 0.25 0.25 0.25" 
print " "
print "# LA mode (+h)"

# Direction LA
# Atome K
i = 0
SBX1 = np.array([eigvectL[i][0],eigvectL[i][1],eigvectL[i][2]])*eigvectL[i][0]*d
isp1 
SBY1 = np.array([eigvectL[i][0],eigvectL[i][1],eigvectL[i][2]])*eigvectL[i][1]*d
isp1 
SBZ1 = np.array([eigvectL[i][0],eigvectL[i][1],eigvectL[i][2]])*eigvectL[i][2]*d
isp1
SBX2 = np.array([eigvectL[i][3],eigvectL[i][4],eigvectL[i][5]])*eigvectL[i][3]*d
isp1 
SBY2 = np.array([eigvectL[i][3],eigvectL[i][4],eigvectL[i][5]])*eigvectL[i][4]*d
isp1 
SBZ2 = np.array([eigvectL[i][3],eigvectL[i][4],eigvectL[i][5]])*eigvectL[i][5]*d
isp1

# Calculs translation
i = 0
TrX  = np.array([1,0,0])*disp2
TrY  = np.array([0,1,0])*disp2
TrZ  = np.array([0,0,1])*disp2

# --------------------------------
# Calcul du terme d2Vhxc/dSBdTB 
# Atomes K
# -------------------------------

#VHX(x,y)
print " xcart2  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(SBX1[0]+TrX[0]), rprim[1]*
0.0+(SBX1[1]+TrX[1]),rprim[2]*0.0+(SBX1[2]+TrX[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(SBX2[0]+TrX[0]), rprim[1]
*0.25+(SBX2[1]+TrX[1]),rprim[2]*0.25+(SBX2[2]+TrX[2]))
print ""

#VHXC(-x,y)
print " xcart3  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(-SBX1[0]+TrX[0]), rprim[1]
*0.0+(-SBX1[1]+TrX[1]),rprim[2]*0.0+(-SBX1[2]+TrX[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(-SBX2[0]+TrX[0]), rprim[1
]*0.25+(-SBX2[1]+TrX[1]),rprim[2]*0.25+(-SBX2[2]+TrX[2]))
print ""

#VHXC(x,-y)
print " xcart4  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(SBX1[0]-TrX[0]), rprim[1]*
0.0+(SBX1[1]-TrX[1]),rprim[2]*0.0+(SBX1[2]-TrX[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(SBX2[0]-TrX[0]), rprim[1]
*0.25+(SBX2[1]-TrX[1]),rprim[2]*0.25+(SBX2[2]-TrX[2]))
print ""

#VHXC(-x,-y)
print " xcart5  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(-SBX1[0]-TrX[0]), rprim[1]
*0.0+(-SBX1[1]-TrX[1]),rprim[2]*0.0+(-SBX1[2]-TrX[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(-SBX2[0]-TrX[0]), rprim[1
]*0.25+(-SBX2[1]-TrX[1]),rprim[2]*0.25+(-SBX2[2]-TrX[2]))
print ""

#VHY(x,y)
print " xcart6  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(SBY1[0]+TrY[0]), rprim[1]*
0.0+(SBY1[1]+TrY[1]),rprim[2]*0.0+(SBY1[2]+TrY[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(SBY2[0]+TrY[0]), rprim[1]
*0.25+(SBY2[1]+TrY[1]),rprim[2]*0.25+(SBY2[2]+TrY[2]))
print ""

#VHYC(-x,y)
print " xcart7  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(-SBY1[0]+TrY[0]), rprim[1]
*0.0+(-SBY1[1]+TrY[1]),rprim[2]*0.0+(-SBY1[2]+TrY[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(-SBY2[0]+TrY[0]), rprim[1
]*0.25+(-SBY2[1]+TrY[1]),rprim[2]*0.25+(-SBY2[2]+TrY[2]))
print ""

#VHYC(x,-y)
print " xcart8  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(SBY1[0]-TrY[0]), rprim[1]*
0.0+(SBY1[1]-TrY[1]),rprim[2]*0.0+(SBY1[2]-TrY[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(SBY2[0]-TrY[0]), rprim[1]
*0.25+(SBY2[1]-TrY[1]),rprim[2]*0.25+(SBY2[2]-TrY[2]))
print ""

#VHYC(-x,-y)
print " xcart9  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(-SBY1[0]-TrY[0]), rprim[1]
*0.0+(-SBY1[1]-TrY[1]),rprim[2]*0.0+(-SBY1[2]-TrY[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(-SBY2[0]-TrY[0]), rprim[1
]*0.25+(-SBY2[1]-TrY[1]),rprim[2]*0.25+(-SBY2[2]-TrY[2]))
print ""

#VHZ(x,y)
print " xcart10  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(SBZ1[0]+TrZ[0]), rprim[1]
*0.0+(SBZ1[1]+TrZ[1]),rprim[2]*0.0+(SBZ1[2]+TrZ[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(SBZ2[0]+TrZ[0]), rprim[1]
*0.25+(SBZ2[1]+TrZ[1]),rprim[2]*0.25+(SBZ2[2]+TrZ[2]))
print ""

#VHZC(-x,y)
print " xcart11  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(-SBZ1[0]+TrZ[0]), rprim[1
]*0.0+(-SBZ1[1]+TrZ[1]),rprim[2]*0.0+(-SBZ1[2]+TrZ[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(-SBZ2[0]+TrZ[0]), rprim[1
]*0.25+(-SBZ2[1]+TrZ[1]),rprim[2]*0.25+(-SBZ2[2]+TrZ[2]))
print ""

#VHZC(x,-y)
print " xcart12  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(SBZ1[0]-TrZ[0]), rprim[1]
*0.0+(SBZ1[1]-TrZ[1]),rprim[2]*0.0+(SBZ1[2]-TrZ[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(SBZ2[0]-TrZ[0]), rprim[1]
*0.25+(SBZ2[1]-TrZ[1]),rprim[2]*0.25+(SBZ2[2]-TrZ[2]))
print ""

#VHZC(-x,-y)
print " xcart13  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+(-SBZ1[0]-TrZ[0]), rprim[1
]*0.0+(-SBZ1[1]-TrZ[1]),rprim[2]*0.0+(-SBZ1[2]-TrZ[2]))
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.25+(-SBZ2[0]-TrZ[0]), rprim[1
]*0.25+(-SBZ2[1]-TrZ[1]),rprim[2]*0.25+(-SBZ2[2]-TrZ[2]))
print ""

#Calculs de Delta lambda1, Delta lambda2
h=np.sqrt(disp1**2+disp2**2)
print "h :", h
