# Find the eigenvector from the dynamical matrice

import numpy as np

def read_dynamical_matrix(datafile):
	with open(datafile,'r') as f:
          raw = list()
          for line in f:
	    if line[0]=='#': continue
	    parts=line.split()
	    if not parts: continue
	    val=float(parts[4])
	    if np.abs(val) < 0.000000001:
	      val=0.0
            raw.append(val)
          dynmat = np.array(raw)
          dynmat = dynmat.reshape(6,6)
	return dynmat


L_file = '/home/Samuel/Dropbox/WorkDiam/DerivEig_L/Dyanmical_mat.dat'

dynmatL=read_dynamical_matrix(L_file)

[eigvalL,eigvectL]=np.linalg.eig(dynmatL)

eigvectL=np.transpose(eigvectL)
Mc=21894.16693

print "eigenvalues at L :"
for n in eigvalL:
  a = np.sqrt(n/Mc)
  print a

print "eigenvectors at L :"
for n in eigvectL: print n

# Create the xcart needed for abinit input file

disp = 0.01
acell = np.array([13.4069361,6.70346805,6.70346805])
rprim = np.array([[0.0,0.5,0.5],[0.5,0.0,0.5],[0.5,0.5,0.0]])

cell = np.mat([rprim[0]*acell[0],rprim[1]*acell[1],rprim[2]*acell[2]])
print "Cell geometry: ", cell

#Reduce coordinate of atoms

xred = np.mat([[0.0,0.0,0.0],[0.125,0.25,0.25],[0.5,0.0,0.0],[0.625,0.25,0.25]]) 
print xred
print (xred[1]*cell)[0,0]


#Count for nb of xcart
j = 1

print "# Equilibrium position" 
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0],(xred[0]*cell)[0,1]
,(xred[0]*cell)[0,2]) 
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0],(xred[1]*cell)[0,1],(xre
d[1]*cell)[0,2]) 
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0],(xred[2]*cell)[0,1],(xre
d[2]*cell)[0,2]) 
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0],(xred[3]*cell)[0,1],(xre
d[3]*cell)[0,2]) 

j += 1

# LA mode (+h)
i = 0
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]+eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]+eigvectL[i][1]*disp,(xred[0]*cell)[0,2]+eigvectL[i][2]*disp)   
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]+eigvectL[i][4]*disp,(xred[1]*cell)[0,2]+eigvectL[i][5]*disp)  
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]-eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]-eigvectL[i][1]*disp,(xred[2]*cell)[0,2]-eigvectL[i][2]*disp)  
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]-eigvectL[i][4]*disp,(xred[3]*cell)[0,2]-eigvectL[i][5]*disp) 
j += 1

# LA mode (-h)
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]-eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]-eigvectL[i][1]*disp,(xred[0]*cell)[0,2]-eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]-eigvectL[i][4]*disp,(xred[1]*cell)[0,2]-eigvectL[i][5]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]+eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]+eigvectL[i][1]*disp,(xred[2]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]+eigvectL[i][4]*disp,(xred[3]*cell)[0,2]+eigvectL[i][5]*disp)
j += 1

# LO mode (+h)
i = 1
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]+eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]+eigvectL[i][1]*disp,(xred[0]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]+eigvectL[i][4]*disp,(xred[1]*cell)[0,2]+eigvectL[i][5]*disp)  
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]-eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]-eigvectL[i][1]*disp,(xred[2]*cell)[0,2]-eigvectL[i][2]*disp)  
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]-eigvectL[i][4]*disp,(xred[3]*cell)[0,2]-eigvectL[i][5]*disp)  
j += 1

# LO mode (-h)
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]-eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]-eigvectL[i][1]*disp,(xred[0]*cell)[0,2]-eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]-eigvectL[i][4]*disp,(xred[1]*cell)[0,2]-eigvectL[i][5]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]+eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]+eigvectL[i][1]*disp,(xred[2]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]+eigvectL[i][4]*disp,(xred[3]*cell)[0,2]+eigvectL[i][5]*disp)
j += 1

# TA mode (+h)
i = 2
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]+eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]+eigvectL[i][1]*disp,(xred[0]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]+eigvectL[i][4]*disp,(xred[1]*cell)[0,2]+eigvectL[i][5]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]-eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]-eigvectL[i][1]*disp,(xred[2]*cell)[0,2]-eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]-eigvectL[i][4]*disp,(xred[3]*cell)[0,2]-eigvectL[i][5]*disp)
j += 1

# TA mode (-h)
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]-eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]-eigvectL[i][1]*disp,(xred[0]*cell)[0,2]-eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]-eigvectL[i][4]*disp,(xred[1]*cell)[0,2]-eigvectL[i][5]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]+eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]+eigvectL[i][1]*disp,(xred[2]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]+eigvectL[i][4]*disp,(xred[3]*cell)[0,2]+eigvectL[i][5]*disp)
j += 1

# TA mode (2ieme) (+h) 
i = 3
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]+eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]+eigvectL[i][1]*disp,(xred[0]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]+eigvectL[i][4]*disp,(xred[1]*cell)[0,2]+eigvectL[i][5]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]-eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]-eigvectL[i][1]*disp,(xred[2]*cell)[0,2]-eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]-eigvectL[i][4]*disp,(xred[3]*cell)[0,2]-eigvectL[i][5]*disp)
j += 1

# TA mode (-h)
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]-eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]-eigvectL[i][1]*disp,(xred[0]*cell)[0,2]-eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]-eigvectL[i][4]*disp,(xred[1]*cell)[0,2]-eigvectL[i][5]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]+eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]+eigvectL[i][1]*disp,(xred[2]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]+eigvectL[i][4]*disp,(xred[3]*cell)[0,2]+eigvectL[i][5]*disp)
j += 1

# TO mode (+h)
i = 4
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]+eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]+eigvectL[i][1]*disp,(xred[0]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]+eigvectL[i][4]*disp,(xred[1]*cell)[0,2]+eigvectL[i][5]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]-eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]-eigvectL[i][1]*disp,(xred[2]*cell)[0,2]-eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]-eigvectL[i][4]*disp,(xred[3]*cell)[0,2]-eigvectL[i][5]*disp)
j += 1

# TO mode (-h)
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]-eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]-eigvectL[i][1]*disp,(xred[0]*cell)[0,2]-eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]-eigvectL[i][4]*disp,(xred[1]*cell)[0,2]-eigvectL[i][5]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]+eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]+eigvectL[i][1]*disp,(xred[2]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]+eigvectL[i][4]*disp,(xred[3]*cell)[0,2]+eigvectL[i][5]*disp)
j += 1

# TO mode (2ieme) (+h)
i = 5
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]+eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]+eigvectL[i][1]*disp,(xred[0]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]+eigvectL[i][4]*disp,(xred[1]*cell)[0,2]+eigvectL[i][5]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]-eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]-eigvectL[i][1]*disp,(xred[2]*cell)[0,2]-eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]-eigvectL[i][4]*disp,(xred[3]*cell)[0,2]-eigvectL[i][5]*disp)
j += 1

# TO mode (-h)
print " xcart%.0f    %.10f  %.10f  %.10f  "%(j,(xred[0]*cell)[0,0]-eigvectL[i][0]*disp
,(xred[0]*cell)[0,1]-eigvectL[i][1]*disp,(xred[0]*cell)[0,2]-eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[1]*cell)[0,0]-eigvectL[i][3]*disp,(xre
d[1]*cell)[0,1]-eigvectL[i][4]*disp,(xred[1]*cell)[0,2]-eigvectL[i][5]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[2]*cell)[0,0]+eigvectL[i][0]*disp,(xre
d[2]*cell)[0,1]+eigvectL[i][1]*disp,(xred[2]*cell)[0,2]+eigvectL[i][2]*disp)
print "           %.10f  %.10f  %.10f  "%((xred[3]*cell)[0,0]+eigvectL[i][3]*disp,(xre
d[3]*cell)[0,1]+eigvectL[i][4]*disp,(xred[3]*cell)[0,2]+eigvectL[i][5]*disp)
j += 1
