# Python script to compute finite differences
import numpy as np
import netCDF4 as nc
import sys
import os
import matplotlib.pyplot as plt

# Read _EIG.nc file
class open_file:
  filename = None
  filefullpath = None
  def __init__(self,directory=None,filename=None):
    if filename == None:return
    if directory == None:directory='.'
    self.filename = filename
    self.filefullpath = '%s/%s' %(directory,filename)
    if self.filefullpath[-7:] == '_EIG.nc':
      self.EIG_file_open(self.filefullpath)

  def EIG_file_open(self,filefullpath):
    if not (os.path.isfile(filefullpath)):
      raise Exception('The file "%s" does not exists!' %filefullpath)
    root = nc.Dataset(filefullpath,'r')
    self.EIG = root.variables['Eigenvalues'][:,:]
    self.Kptns = root.variables['Kptns'][:,:]
    NBandK = root.variables['NBandK'][:]
    self.nband =  np.int(NBandK[0,0])
    root.close()


h=[0.08,0.04,0.02,0.01,0.005,0.0025,0.00125,0.000625,0.0003125,0.00015625,7.8125e-05,3.90625e-05]
etot = [    -1.2075829159E+01 ,   
             -1.2073611271E+01,
             -1.2072914370E+01,
             -1.2075324052E+01,
             -1.2075050153E+01,
             -1.2075732437E+01,
             -1.2075604794E+01,
             -1.2075820351E+01,
             -1.2075757692E+01,
             -1.2075834716E+01,
             -1.2075803532E+01,
             -1.2075834437E+01,
             -1.2075818863E+01,
             -1.2075832424E+01,
             -1.2075824640E+01,
             -1.2075830948E+01,
             -1.2075827056E+01,
             -1.2075830093E+01,
             -1.2075828147E+01,
             -1.2075829636E+01,
             -1.2075828663E+01,
             -1.2075829400E+01,
             -1.2075828913E+01,
             -1.2075829280E+01,
             -1.2075829037E+01,]



hh=[0.0,-0.08,0.08,-0.04,0.04, -0.02,0.02,-0.01,0.01,-0.005,0.005,-0.0025,0.0025,-0.00125,0.00125,-0.000625,0.000625,-0.0003125,0.0003125,-0.00015625,0.00015625,-7.8125e-05,7.8125e-05,-3.90625e-05,3.90625e-05]

eigenEq = open_file()
eigenEq.__init__(directory='.',filename="abo_DS1_EIG.nc")

eigen = np.zeros((len(h)+1,6))
hvalue = np.zeros((len(h)+1,6))
average = np.zeros(((len(h)+1)*2))
average_sym = np.zeros(((len(h)*2+1)))
hvalue_av = np.zeros(((len(h)+1)*2))
deriv2 = np.zeros(((len(h)+1)))


average[2*len(h)+0] = np.sum(eigenEq.EIG[0,0,1]+eigenEq.EIG[0,0,2]+eigenEq.EIG[0,0,3])/3
average[2*len(h)+1] = np.sum(eigenEq.EIG[0,0,1]+eigenEq.EIG[0,0,2]+eigenEq.EIG[0,0,3])/3 # Dummy


h_sym=[-0.08, -0.04, -0.02,-0.01,-0.005,-0.0025,-0.00125,-0.000625,-0.0003125,-0.00015625,-7.8125e-05,-3.90625e-05,3.90625e-05,7.8125e-05,0.00015625,0.0003125,0.000625,0.00125,0.0025,0.005,0.01,0.02,0.04,0.08,0]
average_sym[2*len(h)] = np.sum(eigenEq.EIG[0,0,1]+eigenEq.EIG[0,0,2]+eigenEq.EIG[0,0,3])/3 # Dummy

for ii in np.arange(len(h)):
  #h = 0.02
  eigen1= open_file()
  eigen1.__init__(directory='.',filename="abo_DS"+str(2*ii+2)+"_EIG.nc")
  eigen2= open_file()
  eigen2.__init__(directory='.',filename="abo_DS"+str(2*ii+3)+"_EIG.nc")

# Homo bands at Gamma
  eigen[ii,0] = eigen1.EIG[0,0,1]
  eigen[ii,1] = eigen1.EIG[0,0,2]
  eigen[ii,2] = eigen1.EIG[0,0,3]
  eigen[ii,3] = eigen2.EIG[0,0,1]
  eigen[ii,4] = eigen2.EIG[0,0,2]
  eigen[ii,5] = eigen2.EIG[0,0,3]
  average[2*ii+0] = np.sum(eigen1.EIG[0,0,1]+eigen1.EIG[0,0,2]+eigen1.EIG[0,0,3])/3
  average[2*ii+1] = np.sum(eigen2.EIG[0,0,1]+eigen2.EIG[0,0,2]+eigen2.EIG[0,0,3])/3
  average_sym[ii] = np.sum(eigen1.EIG[0,0,1]+eigen1.EIG[0,0,2]+eigen1.EIG[0,0,3]+eigen2.EIG[0,0,1]+eigen2.EIG[0,0,2]+eigen2.EIG[0,0,3])/6
  average_sym[2*len(h)-ii-1] = np.sum(eigen1.EIG[0,0,1]+eigen1.EIG[0,0,2]+eigen1.EIG[0,0,3]+eigen2.EIG[0,0,1]+eigen2.EIG[0,0,2]+eigen2.EIG[0,0,3])/6
  hvalue_av[2*ii+0] = -h[ii]
  hvalue_av[2*ii+1] = h[ii]

  deriv2[ii] = (average[2*ii+0]+average[2*ii+1]-2*average[2*len(h)+1])/(hvalue_av[2*ii+1]**2)

  hvalue[ii,0] = -h[ii]
  hvalue[ii,1] = -h[ii]
  hvalue[ii,2] = -h[ii]
  hvalue[ii,3] =  h[ii]
  hvalue[ii,4] =  h[ii]
  hvalue[ii,5] =  h[ii]

eigen[len(h),0] = eigenEq.EIG[0,0,1]
eigen[len(h),1] = eigenEq.EIG[0,0,2]
eigen[len(h),2] = eigenEq.EIG[0,0,3]  
eigen[len(h),3] = eigenEq.EIG[0,0,3] # Dummy values 
eigen[len(h),4] = eigenEq.EIG[0,0,3] # Dummy
eigen[len(h),5] = eigenEq.EIG[0,0,3] # Dummy 

hvalue[len(h),:] = 0

# Polyfit
print hvalue_av
print average
print deriv2
print average_sym

# EIG
z = np.polyfit(hvalue_av,average,2)
zz = np.polyfit(h_sym,average_sym,6)
xp = np.linspace(-0.08, 0.08, 200)
p = np.poly1d(z)
pp = np.poly1d(zz)
#plt.plot(xp,p(xp))
#plt.plot(xp,pp(xp),'--')


#plt.plot(hvalue,eigen,'ro') 
#plt.plot(h_sym,average_sym,'bo') 

# ETOTAL
z = np.polyfit(hh,etot,2)
zz = np.polyfit(hh,etot,3)
xp = np.linspace(-0.08, 0.08, 400)
p = np.poly1d(z)
pp = np.poly1d(zz)
print "z: ",z
print "zz: ",zz
plt.plot(xp,p(xp),'--')
plt.plot(xp,pp(xp),'-')
plt. plot(hh,etot,'ro')

#plt.show()

Mcarbone = 21894.16693
preterm = 1.0/Mcarbone
ii=1
while ii <= (len(etot)):
  omega = np.sqrt(preterm*((etot[ii+1]+etot[ii]-2*etot[0])/(hh[ii+1]**2)))
  print "h: ",hh[ii+1] 
  print omega
  ii += 2










