# Make all the calculation using Paul python scripts
import netCDF4 as nc
import numpy as np
import math
import os

# User defined variables
#band = 1 #  for 1  level 
range = np.array([7])
kpt  = np.array([4,19,109,130]) # L point
ii= 2
order = 4
h = np.array([0.02, 0.01, 0.005, 0.0025])
D = np.zeros([len(h),len(h),7])
Mc = 21894.16693
# Frequency (computed in DFPT using ABINIT)
omega = np.array([2.502563E-03,  2.502728E-03,  4.941578E-03,  5.647860E-03,  5.647892E-03, 5.775970E-03])

def use_cut3d(datafile,out,gamma,band):
  if datafile[len(datafile)-4:len(datafile)] == "VHXC":
    os.system("rm cut3d.files")
    with open("cut3d.files","a") as files:
      files.write(str(datafile)+"\n")
      files.write("1 \n")
      files.write("5 \n")  #3D formatted data 
                           #(output the bare 3D data - one column) 
      files.write(str(out)+"\n")
      files.write("0 \n")
    os.system("cut3d < cut3d.files ")
  if datafile[len(datafile)-3:len(datafile)] == "WFK":
    os.system("rm wfk.files")
    with open("wfk.files","a") as files:
      files.write(str(datafile)+"\n")
      files.write("1 \n")
      files.write("0 \n")
      files.write(str(gamma)+" \n") # Gamma point
      files.write(str(band)+" \n") # Band nb 6
      files.write("0 \n")
      files.write("0 \n")
      files.write("1 \n") # real 3D data one column
      files.write(str(out)+" \n")
      files.write("0 \n")
    os.system("cut3d < wfk.files ")

def integration(VHXC,wfk):
  psi_file=open(wfk,'r')
  v_file=open(VHXC,'r')
  S=0.0; N=0.0
  while True:
    psi_l=psi_file.readline()
    v_l=v_file.readline()
    if not psi_l or not v_l: break
    psi_R = float(psi_l.split()[0])
    psi_I = float(psi_l.split()[1])
    v=float(v_l)
    S+=psi_R*v*psi_R + psi_I*v*psi_I
    N+=psi_R*psi_R + psi_I*psi_I
  psi_file.close()
  v_file.close()
  S=S/N
  return S

# NRIA
use_cut3d("primitiveo_DS1_VHXC","EQ",0,0)
use_cut3d("primitiveo_DS1_WFK","wfk",kpt[0],range[0])
use_cut3d("primitiveo_DS1_WFK","wfk",kpt[1],range[0])
use_cut3d("primitiveo_DS1_WFK","wfk",kpt[2],range[0])
use_cut3d("primitiveo_DS1_WFK","wfk",kpt[3],range[0])

ii = 2
while ii < order*12*6+1:
  for jj in np.arange(0,6):
    for kk in np.arange(0,len(kpt)):
      use_cut3d("primitiveo_DS"+str(12*jj+ii)+"_VHXC","V1",0,0)
      V1 = integration("V1","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")      
      use_cut3d("primitiveo_DS"+str(12*jj+ii+1)+"_VHXC","V2",0,0)
      V2 = integration("V2","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")     
      use_cut3d("primitiveo_DS"+str(12*jj+ii+2)+"_VHXC","V3",0,0)
      V3 = integration("V3","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")     
      use_cut3d("primitiveo_DS"+str(12*jj+ii+3)+"_VHXC","V4",0,0)
      V4 = integration("V4","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")     
      directionX = V1+V4-V2-V3
      use_cut3d("primitiveo_DS"+str(12*jj+ii+4)+"_VHXC","V5",0,0)
      V5 = integration("V5","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")      
      use_cut3d("primitiveo_DS"+str(12*jj+ii+5)+"_VHXC","V6",0,0)
      V6 = integration("V6","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")     
      use_cut3d("primitiveo_DS"+str(12*jj+ii+6)+"_VHXC","V7",0,0)
      V7 = integration("V7","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")     
      use_cut3d("primitiveo_DS"+str(12*jj+ii+7)+"_VHXC","V8",0,0)
      V8 = integration("V8","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")     
      directionY = V5+V8-V6-V7
      use_cut3d("primitiveo_DS"+str(12*jj+ii+8)+"_VHXC","V9",0,0)
      V9 = integration("V9","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")      
      use_cut3d("primitiveo_DS"+str(12*jj+ii+9)+"_VHXC","V10",0,0)
      V10 = integration("V10","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")     
      use_cut3d("primitiveo_DS"+str(12*jj+ii+10)+"_VHXC","V11",0,0)
      V11 = integration("V11","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")     
      use_cut3d("primitiveo_DS"+str(12*jj+ii+11)+"_VHXC","V12",0,0)
      V12 = integration("V12","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")     
      directionZ = V9+V12-V10-V11
      preterm = (1.0/(8*Mc*omega[jj]))*27.211383*1000
      D[0,(ii-1)/72,jj] += (1.0/len(kpt))*2*preterm*(directionX+directionY+directionZ)/(4*(h[(ii-1)/72]**2))

  D[0,(ii-1)/72,6] = np.sum(D[0,(ii-1)/72,0:6]) # Sum over modes

  print "h ",h[(ii-1)/72]
  print "NDDW2 TA ",D[0,(ii-1)/72,0] + D[0,(ii-1)/72,1] 
  print "NDDW2 LA ",D[0,(ii-1)/72,2] 
  print "NDDW2 TO ",D[0,(ii-1)/72,3] + D[0,(ii-1)/72,4]
  print "NDDW2 LO ",D[0,(ii-1)/72,5] 
  print "NDDW2 total ",D[0,(ii-1)/72,6] 

  ii += 72

# ------------------------------------------------------------------------
# We will now use the Richardson Extrapolation to speed up the convergence
# ------------------------------------------------------------------------

l = 0
while l < len(h):
  k = 0
  while k < len(h):
    if (l-1) >= 0 and (k-1) >= 0:
#      mode 1  
      D[l,k,0] = (D[l-1,k,0]-(D[l-1,k-1,0]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#      mode 2
      D[l,k,1] = (D[l-1,k,1]-(D[l-1,k-1,1]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#      mode 3  
      D[l,k,2] = (D[l-1,k,2]-(D[l-1,k-1,2]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#      mode 4  
      D[l,k,3] = (D[l-1,k,3]-(D[l-1,k-1,3]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#      mode 5  
      D[l,k,4] = (D[l-1,k,4]-(D[l-1,k-1,4]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#      mode 6  
      D[l,k,5] = (D[l-1,k,5]-(D[l-1,k-1,5]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#     sum modes  
      D[l,k,6] = (D[l-1,k,6]-(D[l-1,k-1,6]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
      if D[l-1,k-1,0] == 0.0:
        D[l,k,0] = 0.0
      if D[l-1,k-1,1] == 0.0:
        D[l,k,1] = 0.0
      if D[l-1,k-1,2] == 0.0:
        D[l,k,2] = 0.0
      if D[l-1,k-1,3] == 0.0:
        D[l,k,3] = 0.0
      if D[l-1,k-1,4] == 0.0:
        D[l,k,4] = 0.0
      if D[l-1,k-1,5] == 0.0:
        D[l,k,5] = 0.0
      if D[l-1,k-1,6] == 0.0:
        D[l,k,6] = 0.0
    k += 1
  l += 1

NDDW2 = D[:,:,6]
D = np.zeros([len(h),len(h),7])
# NRIA
use_cut3d("primitive2o_DS1_VHXC","EQ",0,0)
use_cut3d("primitive2o_DS1_WFK","wfk",kpt[0],range[0])
use_cut3d("primitive2o_DS1_WFK","wfk",kpt[1],range[0])
use_cut3d("primitive2o_DS1_WFK","wfk",kpt[2],range[0])
use_cut3d("primitive2o_DS1_WFK","wfk",kpt[3],range[0])
EQ = np.zeros((len(kpt)))
EQ[0]  = integration("EQ","wfk_k"+str(kpt[0])+"_b"+str(range[0])+"_s1")
EQ[1]  = integration("EQ","wfk_k"+str(kpt[1])+"_b"+str(range[0])+"_s1")
EQ[2]  = integration("EQ","wfk_k"+str(kpt[2])+"_b"+str(range[0])+"_s1")
EQ[3]  = integration("EQ","wfk_k"+str(kpt[3])+"_b"+str(range[0])+"_s1")

ii = 2
while ii < order*4*6+1:
  for jj in np.arange(0,6):
    for kk in np.arange(0,len(kpt)):
      use_cut3d("primitive2o_DS"+str(4*jj+ii)+"_VHXC","V1",0,0)
      V1 = integration("V1","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")
      use_cut3d("primitive2o_DS"+str(4*jj+ii+1)+"_VHXC","V2",0,0)
      V2 = integration("V2","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")
      use_cut3d("primitive2o_DS"+str(4*jj+ii+2)+"_VHXC","V3",0,0)
      V3 = integration("V2","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")
      use_cut3d("primitive2o_DS"+str(4*jj+ii+3)+"_VHXC","V4",0,0)
      V4 = integration("V4","wfk_k"+str(kpt[kk])+"_b"+str(range[0])+"_s1")
      preterm = (1.0/(4*Mc*omega[jj]))*27.211383*1000
      D[0,(ii-1)/24,jj] += (1.0/len(kpt))*(preterm*(V1+V2-2*EQ[kk])/(h[(ii-1)/24]**2) + preterm*(V3+V4-2*EQ[kk])/(h[(ii-1)/24]**2))

  D[0,(ii-1)/24,6] = np.sum(D[0,(ii-1)/24,0:6]) # Sum over modes


  print "h ",h
  print "NDDW3 TA ",D[0,(ii-1)/24,0] + D[0,(ii-1)/24,1]
  print "NDDW3 LA ",D[0,(ii-1)/24,2]
  print "NDDW3 TO ",D[0,(ii-1)/24,3] + D[0,(ii-1)/24,4]
  print "NDDW3 LO ",D[0,(ii-1)/24,5]
  print "NDDW3 total ",D[0,(ii-1)/24,6]

  ii += 24

# ------------------------------------------------------------------------
# We will now use the Richardson Extrapolation to speed up the convergence
# ------------------------------------------------------------------------

l = 0
while l < len(h):
  k = 0
  while k < len(h):
    if (l-1) >= 0 and (k-1) >= 0:
#      mode 1  
      D[l,k,0] = (D[l-1,k,0]-(D[l-1,k-1,0]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#      mode 2
      D[l,k,1] = (D[l-1,k,1]-(D[l-1,k-1,1]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#      mode 3  
      D[l,k,2] = (D[l-1,k,2]-(D[l-1,k-1,2]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#      mode 4  
      D[l,k,3] = (D[l-1,k,3]-(D[l-1,k-1,3]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#      mode 5  
      D[l,k,4] = (D[l-1,k,4]-(D[l-1,k-1,4]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#      mode 6  
      D[l,k,5] = (D[l-1,k,5]-(D[l-1,k-1,5]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
#     sum modes  
      D[l,k,6] = (D[l-1,k,6]-(D[l-1,k-1,6]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
      if D[l-1,k-1,0] == 0.0:
        D[l,k,0] = 0.0
      if D[l-1,k-1,1] == 0.0:
        D[l,k,1] = 0.0
      if D[l-1,k-1,2] == 0.0:
        D[l,k,2] = 0.0
      if D[l-1,k-1,3] == 0.0:
        D[l,k,3] = 0.0
      if D[l-1,k-1,4] == 0.0:
        D[l,k,4] = 0.0
      if D[l-1,k-1,5] == 0.0:
        D[l,k,5] = 0.0
      if D[l-1,k-1,6] == 0.0:
        D[l,k,6] = 0.0
    k += 1
  l += 1

NDDW3 = D[:,:,6]

print "NDDW2 ",NDDW2
print "NDDW3 ",NDDW3



