# Find the eigenvector from the dynamical matrice

import numpy as np

def read_dynamical_matrix(datafile):
	with open(datafile,'r') as f:
          raw = list()
          for line in f:
	    if line[0]=='#': continue
	    parts=line.split()
	    if not parts: continue
	    val=float(parts[4])
	    if np.abs(val) < 0.000000001:
	      val=0.0
            raw.append(val)
          dynmat = np.array(raw)
          dynmat = dynmat.reshape(6,6)
	return dynmat


L_file = '/home/Samuel/Dropbox/WorkDiam/DerivEig_L/Dyanmical_mat.dat'

dynmatL=read_dynamical_matrix(L_file)

[eigvalL,eigvectL]=np.linalg.eig(dynmatL)

eigvectL=np.transpose(eigvectL)
Mc=21894.16693

print "eigenvalues at L :"
for n in eigvalL:
  a = np.sqrt(n/Mc)
  print a

print "eigenvectors at L :"
for n in eigvectL: print n

# Create the xcart needed for abinit input file

disp = 0.03
rprim = np.array([13.4069361,6.70346805,6.70346805])


print "# Equilibrium position" 
print " xcart1  0.0  0.0  0.0                     # 0.0 0.0 0.0 "
print "         1.67586701 1.67586701 1.67586701  # 0.125 0.25 0.25" 
print "         6.70346805 0.00 0.00              # 0.5 0.0 0.0 "
print "         8.37933506 1.67586701 1.67586701  # 0.625 0.25 0.25 "
print " "
print "# LA mode"
i = 0
print " xcart2  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+eigvectL[i][0]*disp, 
rprim[1]*0.0+eigvectL[i][1]*disp,rprim[2]*0.0+eigvectL[i][2]*disp)
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.125+eigvectL[i][3]*disp, 
rprim[1]*0.25+eigvectL[i][4]*disp,rprim[2]*0.25+eigvectL[i][5]*disp)
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.5-eigvectL[i][0]*disp,
 rprim[1]*0.0-eigvectL[i][1]*disp,rprim[2]*0.0-eigvectL[i][2]*disp)
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.625-eigvectL[i][3]*disp,
 rprim[1]*0.25-eigvectL[i][4]*disp,rprim[2]*0.25-eigvectL[i][5]*disp)
print ""
print "# L0 mode "
i = 1
print " xcart3  %.10f  %.10f  %.10f  "%(rprim[0]*0.0+eigvectL[i][0]*disp, 
rprim[1]*0.0+eigvectL[i][1]*disp,rprim[2]*0.0+eigvectL[i][2]*disp)
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.125+eigvectL[i][3]*disp,
 rprim[1]*0.25+eigvectL[i][4]*disp,rprim[2]*0.25+eigvectL[i][5]*disp)
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.5-eigvectL[i][0]*disp, 
rprim[1]*0.0-eigvectL[i][1]*disp,rprim[2]*0.0-eigvectL[i][2]*disp)
print "         %.10f  %.10f  %.10f  "%(rprim[0]*0.625-eigvectL[i][3]*disp, 
rprim[1]*0.25-eigvectL[i][4]*disp,rprim[2]*0.25-eigvectL[i][5]*disp)
print ""
print "# TA mode "
i = 2
...
